--done
import Data.List (sortBy)

type Nome = String
type Media = Double
type Id = Int
type NumeroVagas = Int
data Professor = Adjunto Nome | Oficial Nome deriving (Show)
data Aluno = Blocado Nome Media | NaoBlocado Nome Media deriving (Show, Eq)
data Disciplina = Nome Professor [Aluno] deriving (Show)


funcao :: [Char] -> NumeroVagas -> (Nome, Id) -> [Aluno] -> Disciplina
funcao nome qtd (prof, id) lista
	| even id = Nome nome (Oficial prof) (take qtd (classifica lista))
	| otherwise = Nome nome (Adjunto prof) (take qtd (classifica lista))

classifica :: [Aluno] -> [Aluno]
classifica lista = sortBy sortA lista
	
sortA :: Aluno -> Aluno -> Ordering
sortA a1 a2
	| compareA a1 a2 == a1 = LT
	| otherwise            = GT
	
compareA :: Aluno -> Aluno -> Aluno
compareA (Blocado a1 m1) (NaoBlocado a2 m2) = (Blocado a1 m1)
compareA (NaoBlocado a1 m1) (Blocado a2 m2) = (Blocado a2 m2)
compareA (Blocado a1 m1) (Blocado a2 m2)
	| m1 > m2   = (Blocado a1 m1)
	| otherwise = (Blocado a2 m2) 
compareA (NaoBlocado a1 m1) (NaoBlocado a2 m2) 
	| m1 > m2  = (NaoBlocado a1 m1)
	|otherwise = (NaoBlocado a2 m2)


--Caso de teste
--funcao "algoritmos" 50 ("Katia", 2) [(Blocado "luiz" 9),(Blocado "victor" 8),(NaoBlocado "joao" 6),(NaoBlocado "marcelo" 7.5),(NaoBlocado "felipe" 7)]