--done
data Tree a = EmptyTree | Node a (Tree a) (Tree a) deriving (Show, Read, Eq)

singleTon :: a -> Tree a
singleTon x = Node x EmptyTree EmptyTree

treeInsert :: (Ord a) => a -> Tree a -> Tree a
treeInsert x EmptyTree = singleTon x
treeInsert x (Node a left right)
	| x == a = Node x left right
	| x < a  = Node a (treeInsert x left) right
	| x > a  = Node a left (treeInsert x right)

treeElem :: (Ord a) => a -> Tree a -> Bool
treeElem _ EmptyTree = False
treeElem x (Node a left right)
	|x == a = True
	|x < a  = treeElem x left
	|x > a  = treeElem x right
	
treeFill :: (Ord a) => [a] -> Tree a -> Tree a
treeFill [] tree = tree
treeFill (a:as) tree = treeFill as (treeInsert a tree)

removerNo :: (Ord a) => Tree a -> Tree a -> Tree a
removerNo EmptyTree _ = EmptyTree
removerNo (Node a left right) (Node x _ _)
	| x == a = switcher (Node a left right)
	| x < a  = Node a (removerNo left (Node x EmptyTree EmptyTree)) right
	| x > a  = Node a left (removerNo right (Node x EmptyTree EmptyTree))
	
switcher :: (Ord a) => Tree a -> Tree a
switcher (Node _ EmptyTree EmptyTree) = EmptyTree
switcher (Node _ left EmptyTree) = left
switcher (Node _ EmptyTree right) = right
switcher (Node _ left right) = Node x left right'
	where x = sucessor right
	      right' = removerNo right (Node x EmptyTree EmptyTree)
	      sucessor (Node a EmptyTree right) = a
	      sucessor (Node a left right) = sucessor left
		  
--Caso teste
-- removerNo (treeFill [Ord a] EmptyTree) (Node a EmptyTree EmptyTree)
-- removerNo (Tree a) (Tree a)
-- removerNo (treeFill [5,4,6,8] EmptyTree) (Node 6 EmptyTree EmptyTree)
-- removerNo (Node 7 (Node 4 EmptyTree EmptyTree) (Node 10 (Node 8 EmptyTree EmptyTree) (Node 12 EmptyTree EmptyTree))) (Node 10 EmptyTree EmptyTree)